<?php
/*                                                       */
/* listservices.php - List services sort by addresses    */
/* $ID 090g - 2023-09-04 - brom $                        */
/*                                                       */
/* BROM CMS/BelCal Project  <http://www.brom-belcal.de> */
/*                                                       */
/* BROM CMS/BelCal is software you can redistribute it  */
/* under the terms the BROM CMS/BelCal license for free */
/* and modify scripts but without warranty. It is not    */
/* redistributable for payment.                          */
/*                                                       */
/* A distribution of payment will be provided            */
/* exclusively by BROM Service see website or send mail. */
/*                                                       */
/* (c) by BROM-Service 2023  (kontakt@brom-belcal.de)    */
/*                                                       */

require('../../config/config.php');
require_once(BC_PATH.'/lib/classes/class.admin.php');
require_once(BC_PATH.'/lib/functions.php');
$admin = new admin('Objects','objects_settings','system');
$user_id = $admin->get_user_id();
if(file_exists(BC_PATH.'/lib/winopen.inc.php')){ include(BC_PATH.'/lib/winopen.inc.php'); }
// Function get lines for textareabox
function get_lines($str=''){
	$str_lines = 1;
	$splitstr = explode("\n",$str);
	$str_lines += count($splitstr);
	foreach($splitstr AS $lineK => $lineV){
		if(strlen($lineV) > 90){
			$str_lines += (strlen($lineV)/90);
		}
	}
	return $str_lines;
}

// Add table for email settings and sended documents
$emailset = "CREATE TABLE IF NOT EXISTS `".TABLE_PREFIX."cal_sendservices` (`calservsend_id` INT NOT NULL auto_increment,"
         . " `user_id` INT NOT NULL,"
         . " `send_type` TINYINT(1) NOT NULL,"
         . " `send_copy` TINYINT(1) NOT NULL,"
         . " `res_range` TINYINT(1) NOT NULL,"
         . " `subject` VARCHAR(60) NOT NULL DEFAULT '',"
         . " `pretext` LONGTEXT NOT NULL,"
         . " `signum` TEXT NOT NULL,"
         . " `filterset` VARCHAR(255) NOT NULL DEFAULT '',"
         . " PRIMARY KEY ( `calservsend_id` )"
         . " )";
$datapdo->query($emailset);
$sendeddocs = "CREATE TABLE IF NOT EXISTS `".TABLE_PREFIX."cal_servicesdocs` (`calservdoc_id` INT NOT NULL auto_increment,"
         . " `user_id` INT NOT NULL,"
         . " `send_type` TINYINT(1) NOT NULL,"
         . " `sended_to` INT NOT NULL,"
         . " `subject` VARCHAR(60) NOT NULL DEFAULT '',"
         . " `document` TEXT NOT NULL,"
         . " `senddate` INT NOT NULL,"
         . " PRIMARY KEY ( `calservdoc_id` )"
         . " )";
$datapdo->query($sendeddocs);
// Check the field filterset
$field = false;
$get_fileds = $datapdo->query("SHOW FIELDS FROM `".TABLE_PREFIX."cal_sendservices`");
while($rows = $datapdo->fetchRow($get_fileds)){
  if($rows[0]=='filterset'){ $field = true; }
}
if($field == false){
  $datapdo->query("ALTER TABLE `".TABLE_PREFIX."cal_sendservices` ADD `filterset` VARCHAR(255) NOT NULL DEFAULT ''");
}
if($datapdo->numRows($datapdo->query("SELECT `calservsend_id` FROM `".TABLE_PREFIX."cal_sendservices` WHERE `user_id`='$user_id' LIMIT 0,1"))==0){
  // Get now the presettings for email and setit to table
  if($datapdo->numRows($datapdo->query("SHOW TABLES LIKE '".TABLE_PREFIX."mailboxes'"))>0){
    $get_imapsettings = $datapdo->query("SELECT `signature` FROM `".TABLE_PREFIX."mailboxes` WHERE `user_id`='$user_id' ORDER BY `position` LIMIT 0,1");
    if($datapdo->numRows($get_imapsettings)>0){
      $get_sign = $datapdo->fetchRow($get_imapsettings);
      $signature = $get_sign['signature'];
      $send_copy = 0;
    }
    else{
      $signature = $admin->get_display_name();
      $send_copy = 1;
    }
  }
  else{
    $signature = $admin->get_display_name();
    $send_copy = 1;
  }
  $subject = $TEXT['RESERVATIONS'].' - '.$TEXT['CURRENT'];
  $pretext = $TEXT['FILE'].' '.$TEXT['WITH'].' '.$TEXT['RESERVATIONS'].' '.$MESSAGE['ATTACHMENT']['ADD_AS_PDF'].'\n'.$MESSAGE['ATTACHMENT']['PDF_INFO'];
  $datapdo->query("INSERT INTO `".TABLE_PREFIX."cal_sendservices` (`user_id`,`send_type`,`send_copy`,`subject`,`pretext`,`signum`) VALUES ('$user_id','1','$send_copy','$subject','$pretext','$signature')");
}
$printlist_error = '';
if(!$admin->get_permission('calendar_options','module')){
  $admin->print_error($MESSAGE['ADMIN']['INSUFFICIENT_PRIVELLIGES']);
}
else{
  // Include diferent language from modul emeiltemplates
  if(!file_exists(BC_PATH .'/modules/emailtemplates/languages/'.LANGUAGE .'.php')) {
    // no module language file exists for the language set by the user, include default module language file EN.php
    require(BC_PATH .'/modules/emailtemplates/languages/EN.php');
  }
  else {
    // a module language file exists for the language defined by the user, load it
    require(BC_PATH .'/modules/emailtemplates/languages/'.LANGUAGE .'.php');
  }
  if(file_exists(BC_PATH .'/modules/emailtemplates/languages/user_'.LANGUAGE .'.php')) {
    require(BC_PATH .'/modules/emailtemplates/languages/user_'.LANGUAGE .'.php');
  }
  echo '<script type="text/javascript">'."\n";
  echo 'var pageReload;'."\n";
  echo '$(document).ready(function(){'."\n";
  echo '  $(".autoselect").click(function(){'."\n";
  echo '    var checkedservices = ""'."\n";
  echo '    $(".autoselect:checked").each(function(){'."\n";
  echo '      checkedservices = checkedservices + (checkedservices!="" ?"|":"") + $(this).val();'."\n";
  echo '    });'."\n";
  echo '    var servlink = "'.ADMIN_URL.'/addresses/setservvars.php?newfilter=" + checkedservices;'."\n";
  echo '    $("#noBox").load(servlink,function(result){'."\n";
  echo '      setTimeout(location.reload(),1000);'."\n";
  echo '    });'."\n";
  echo '  });'."\n";
  echo '});'."\n";
  echo 'function sort_service(aORo){'."\n";
  echo '  var sortlink = "'.ADMIN_URL.'/addresses/setservvars.php?newsorter=" + aORo;'."\n";
  echo '  $("#noBox").load(sortlink,function(result){'."\n";
  echo '    if(result == "O"){'."\n";
  echo '      $("#emailblock").hide();'."\n";
  echo '      $("#listsorterA").hide();'."\n";
  echo '      $("#listsorterO").show();'."\n";
  echo '    }'."\n";
  echo '    else{'."\n";
  echo '      $("#emailblock").show();'."\n";
  echo '      $("#listsorterA").show();'."\n";
  echo '      $("#listsorterO").hide();'."\n";
  echo '    }'."\n";
  echo '    setTimeout(location.reload(),500);'."\n";
  echo '  });'."\n";
  echo '}'."\n";
  echo 'function print_list(tmpfile,tmptitle){'."\n";
  echo '  openWin(tmpfile,tmptitle);'."\n";
  echo '}'."\n";
  echo '</script>'."\n";
  // Output first the settings for send an email
  $get_emailset = $datapdo->query("SELECT * FROM `".TABLE_PREFIX."cal_sendservices` WHERE `user_id`='$user_id' LIMIT 1");
  $emailset = $datapdo->fetchRow($get_emailset);
  $email_type = $emailset['send_type'];
  $email_type_out = ($email_type==1?'PDF':'HTML');
  $email_copy = $emailset['send_copy'];
  $email_resrange = (isset($emailset['res_range'])?$emailset['res_range']:0);
  $email_pretext = $emailset['pretext'];
  $email_sign = $emailset['signum'];
  $email_subject = $emailset['subject'];
  $filterset = ($emailset['filterset']!=''?explode('|',$emailset['filterset']):array());
  foreach($filterset AS $K => $V){
    $_SESSION['SERVICE_FILTER'][$V]=$V;
  }
  // Set filter for address
  $adr_where = '';
  $isfilter = array();
  if(isset($_SESSION['SERVICE_FILTER'])){
    $isfilter = $_SESSION['SERVICE_FILTER'];
  }
  $height_signum = get_lines($email_sign);
  $height_pretext = get_lines($email_pretext);
  if(!isset($_SESSION['SERVLISTSORTING']) OR $_SESSION['SERVLISTSORTING']=='A'){
    $displayadrsort = '';
    $displayobjsort = 'display:none;';
  }
  else{
    $displayadrsort = 'display:none;';
    $displayobjsort = '';
  }
  echo '<div id="emailblock" style="width:100%;'.$displayadrsort.'">'."\n";
  echo '<div style="float:right;"><input type="button" name="selsorter" value="'.$TEXT['SORT_BY'].' '.$MENU['OBJECTS'].'" onclick="sort_service(\'O\');" /></div>'."\n";
  echo '<h2>'.$TEXT['EMAIL'].'-'.$HEADING['MY_SETTINGS']."\n";
  echo '<div class=""style="text-align:center;display:inline;border:1px solid;padding:0px 2px 0px 2px;cursor:pointer;" onmouseover="$(\'#helper1\').show();" onmouseout="$(\'#helper1\').hide();"><b>?</b></div>'."\n";
  echo '<div id="helper1" class="formInfoBox" style="margin-left:10%;font-size:0.8em;color:#555555;border:1px solid #555555;width:400px;padding:3px;box-shadow: 8px 8px 12px grey;">'."\n";
  echo '<p>'.$TEXT['NOTICE'].':<br />'.$MASSAGE['SERVICES']['MAIL_INFO'].'</p></div>'."\n";
  echo '</h2>'."\n";
  echo '<form name="emeilset" action="'.ADMIN_URL.'/addresses/save_mailservset.php" method="post">'."\n";
  echo '<input type="hidden" name="userid" value="'.$user_id.'" />'."\n";
  echo '<table class="row_c" width="100%" cellspacing="0" cellpadding="2" border="0">'."\n";
  echo '<tr><td class="setting_name" style="vertical-align:top;">'.$TEXT['SUBJECT'].':</td>'."\n";
  echo '<td colspan="2" class="setting_value" style="vertical-align:top;"><input type="text" name="subject" value="'.$email_subject.'" /></td>'."\n";
  echo '</tr>'."\n";
  echo '<tr><td class="setting_name" style="vertical-align:top;">'.$MAILEDIT['MAILPRETEXT'].':</td>'."\n";
  echo '<td colspan="2" class="setting_value" style="vertical-align:top;"><textarea name="pretext" style="height:'.$height_pretext.'em;">'.$email_pretext.'</textarea></td>'."\n";
  echo '</tr>'."\n";
  echo '<tr><td class="setting_name" style="vertical-align:top;">'.$TEXT['SIGNUM'].':</td>'."\n";
  echo '<td colspan="2" class="setting_value" style="vertical-align:top;"><textarea name="signum" style="height:'.$height_signum.'em;">'.$email_sign.'</textarea></td>'."\n";
  echo '</tr>'."\n";
  echo '<tr><td class="setting_name" style="vertical-align:top;">'.$TEXT['TYPE'].' '.lcfirst($MAILEDIT['TO_SEND']).':</td>'."\n";
  echo '<td class="setting_value50" style="vertical-align:top;">'."\n";
  echo '<input type="radio" id="send_type_pdf" name="send_type" value="1"'.($email_type == 1?' checked="checked"':'').' />'."\n";
  echo '<label for="send_type_pdf">PDF</label>'."\n";
  echo '<input type="radio" id="send_type_html" name="send_type" value="0"'.($email_type == 0?' checked="checked"':'').' />'."\n";
  echo '<label for="send_type_html">HTML</label>'."\n";
  echo '<input type="checkbox" id="send_copy" name="send_copy" value="1"'.($email_copy==1?' checked="checked"':'').' />'."\n";
  echo '<label for="send_copy">'.$TEXT['NEWSLETTER_SEND_COPY'].'</label>'."\n";
  echo '</td>'."\n";
  echo '<td class="setting_value50" style="vertical-align:top;">'."\n";
  echo '<label for="res_range">'.$MASSAGE['SERVICES']['RES_RANGE'].':</label>'."\n";
  echo '<select id="res_range" name="res_range" style="width:40%;">'."\n";
  echo '  <option value="0">'.$TEXT['NO_LIMIT'].'</option>'."\n";
  for($month = 1;$month<6;$month++){
  echo '  <option value="'.$month.'"'.($email_resrange==$month?' selected="selected"':'').'>'.$MASSAGE['SERVICES']['RES_RANGE'.$month].'</option>'."\n";
  }
  echo '</select>'."\n";
  echo '</td>'."\n";
  echo '</tr>'."\n";
  echo '<tr><td colspan="3">'."\n";
  echo '<input type="submit" name="savemailset" value="'.$HEADING['MY_SETTINGS'].' '.strtolower($TEXT['SAVE']).'" style="width:100%;" />'."\n";
  echo '</td>'."\n";
  echo '</table>'."\n";
  echo '</form>'."\n";
  echo '</div>'."\n";
  // Output head line
  if(!isset($_SESSION['SERVLISTSORTING']) OR $_SESSION['SERVLISTSORTING']=='A'){
    echo '<h2 id="headerA" style="width:60%;">'.$TEXT['ASSIGNMENT_SERVICES'];
    echo ' - '.$TEXT['SORT_BY'].' '.$MENU['ADRESSDATA']."\n";
    echo '<div style="text-align:center;display:inline;border:1px solid;padding:0px 2px 0px 2px;cursor:pointer;" onmouseover="$(\'#helper2\').show();" onmouseout="$(\'#helper2\').hide();"><b>?</b></div>'."\n";
    echo '<div id="helper2" class="formInfoBox" style="margin-left:30%;font-size:0.8em;color:#555555;border:1px solid #555555;width:400px;padding:3px;box-shadow: 8px 8px 12px grey;">'."\n";
    echo '<p>'.$MASSAGE['SERVICES']['LIST_INFO'].'</p></div></h2>'."\n";
  }
  else{
    echo '<div style="float:right;">'."\n";
    $tmpfile = BC_URL.'/temp/servicelist.pdf';
    $tmptitle = $TEXT['ASSIGNMENT_SERVICES'];
    echo '<input type="button" id="printbutton" name="servprinter" value="'.$TEXT['PRINT'].'" onclick="openWin(\''.$tmpfile.'\',\''.$tmptitle.'\');" />';
    echo '<input type="button" name="selsorter" value="'.$TEXT['SORT_BY'].' '.$MENU['ADRESSDATA'].'" onclick="sort_service(\'A\');" />';
    echo '</div>'."\n";
    echo '<h2 style="width:60%;">'.$TEXT['ASSIGNMENT_SERVICES'];
    echo ' - '.$TEXT['SORT_BY'].' '.$MENU['OBJECTS'].'</h2>'."\n";
  }

  // Output table for setting filter
  echo '<form name="setfilter" action="'.ADMIN_URL.'/addresses/setservvars.php" method="get">'."\n";
  echo '<table class="row_c" width="100%" cellspacing="0" cellpadding="2" border="0">'."\n";
  echo '<tr>'."\n";
  echo '<th colspan="4">'.$MESSAGE['SERVICES']['SET_ADRFILTER'].'</th></tr>'."\n";
  // Get all types
  $getall_adr_types = $datapdo->query("SELECT * FROM `".TABLE_PREFIX."address_types`");
  $count_type = 1;
  echo '<tr><td><input class="autoselect" type="checkbox" id="typefilter_0" name="typefilter[0]" value="0"'.(isset($isfilter[0])?' checked="checked"':'').' />';
  echo '<label for="typefilter_0">'.$TEXT['UNASSIGNED'].'</label></td>'."\n";
  while($all_adr_types = $datapdo->fetchRow($getall_adr_types)){
    $adr_typeid = $all_adr_types['adrtype_id'];
    $adr_typenames = unserialize($all_adr_types['type_names']);
    $adr_typename = $adr_typenames[LANGUAGE];
    if(($count_type % 4)==0){ echo '<tr>'; }
    echo '<td><input class="autoselect" type="checkbox" id="typefilter_'.$adr_typeid.'" name="typefilter['.$adr_typeid.']" value="'.$adr_typeid.'"'.(isset($isfilter[$adr_typeid])?' checked="checked"':'').' />';
    echo '<label for="typefilter_'.$adr_typeid.'">'.$adr_typename.'</label></td>'."\n";
    $count_type++;
    if(($count_type % 4)==0){ echo '</tr>'."\n"; }
  }
  $cspan = 4-($count_type % 4);
  echo '<td colspan="'.$cspan.'" style="text-align:'.($cspan==4?'center':'right').'"><input class="autoselect" type="button" id="setit" name="setit" value="'.$TEXT['EXECUTE'].'" style="width:98%;" />';
  echo '</td>'."\n";
  echo '</tr>'."\n";
  echo '</table>'."\n";
  echo '</form>'."\n";
  $list_array = array();
  // Get all addresses like sorting for user
  $sorting = $datapdo->get_one("SELECT `adr_sort` FROM `".TABLE_PREFIX."users` WHERE `user_id`='$user_id' LIMIT 1");
  switch ($sorting){
    case 1:
      $sort_by = "`prename`,`name`,`city`";
      break;
    case 2:
      $sort_by = "`city`,`name`,`prename`";
      break;
    case 3:
      $sort_by = "`client_id`,`name`,`prename`";
      break;
    case 0:
    default:
      $sort_by = "`name`,`prename`,`city`";
  }
  $get_all_address = $datapdo->query("SELECT `address_id`,`adr_type` FROM `".TABLE_PREFIX."address` ORDER BY $sort_by ASC");
//  $get_all_address = $datapdo->query("SELECT `address_id` FROM `".TABLE_PREFIX."address`".$adr_where." ORDER BY $sort_by ASC");
  if($datapdo->numRows($get_all_address)>0){
    while($all_address = $datapdo->fetchRow($get_all_address)){
      $chk_adrtype = explode('|',$all_address['adr_type']);
      $filteradress = true;
      if(count($isfilter)>0){
        foreach($isfilter AS $fK => $fV){
          if(is_numeric(array_search($fV,$chk_adrtype))){ $filteradress = false; }
        }
      }
      else{ $filteradress = false; }
      if($filteradress==true){ continue 1; }
      $adr_id = $all_address['address_id'];
      // Get all services this address
      $get_services = $datapdo->query("SELECT * FROM `".TABLE_PREFIX."cal_services` WHERE `saddr_id`='$adr_id' ORDER by `object_id` ASC");
      if($datapdo->numRows($get_services)>0){
        if(!isset($list_array[$adr_id])){ $list_array[$adr_id] = array(); }
        while($services = $datapdo->fetchRow($get_services)){
          $get_freeflds = $services['freeflds'];
          if($get_freeflds != ''){
            $freeflds = unserialize($get_freeflds);
            $freefld = (isset($freeflds[LANGUAGE])?$freeflds[LANGUAGE]:'');
          }
          else{ $freefld = ''; }
          $label = $TEXT['UNKNOWN'];
          $get_labels = $datapdo->query("SELECT `labels` FROM `".TABLE_PREFIX."cal_servicelabels` WHERE `slabel_id`='".$services['slabel_id']."' LIMIT 0,1");
          if($datapdo->numRows($get_labels)>0){
            $lb = $datapdo->fetchRow($get_labels,false);
            if($lb['labels'] != ''){
              $labels = unserialize($lb['labels']);
              $label = (isset($labels[LANGUAGE])?$labels[LANGUAGE]:$TEXT['UNKNOWN']);
            }
          }
          $list_servarray = array('label'=>$label,'freefld'=>$freefld,'object'=>$services['object_id']);
          array_push($list_array[$adr_id],$list_servarray);
        }
      }
    }
  }
  if(count($list_array)>0){
    $objlist = array();
    foreach($list_array AS $aID => $sArr){
      $a_company = $admin->get_company($aID);
      $a_name = $admin->get_adr_name($aID);
      $a_prename = $admin->get_adr_prename($aID);
      $a_city = $admin->get_city($aID);
      $a_phone = $admin->get_phone($aID);
      $a_client = $admin->get_client_id($aID);
      $a_mail = $admin->get_email($aID);
      switch ($sorting){
        case 1:
          $s_address = (!empty($a_prename)?$a_prename.' ':'').$a_name.(!empty($a_company)?', '.$a_company:'').(!empty($a_city)?' - '.$a_city:'');
        break;
        case 2:
          $s_address = (!empty($a_city)?$a_city.', ':'').$a_name.(!empty($a_prename)?$a_prename.' ':'').(!empty($a_company)?$a_company.', ':'');
          break;
        case 3:
          $s_address = $a_client.' - '.$a_name.(!empty($a_prename)?', '.$a_prename:'').(!empty($a_company)?', '.$a_company:'').(!empty($a_city)?' - '.$a_city:'');
          break;
        case 0:
        default:
          $s_address = $a_name.(!empty($a_prename)?', '.$a_prename:'').(!empty($a_company)?', '.$a_company:'').(!empty($a_city)?' - '.$a_city:'');
      }
      $output_list[$aID] = array('adrmail'=>$a_mail,'address'=>$s_address,'services'=>array());
      foreach($sArr AS $sID => $vArr){
        $o_id = $vArr['object'];
        $o_number = $admin->zero_to_number($o_id,3);
        $o_title = get_object_title($vArr['object']);
        $s_label = $vArr['label'];
        $s_free = $vArr['freefld'];
        array_push($output_list[$aID]['services'],array('objid'=>$o_id,'obj'=>$o_number.'-'.$o_title,'slabel'=>$s_label,'sfreefld'=>$s_free));
        if(!isset($objlist[$o_id])){ $objlist[$o_id]=array('obj_title'=>$o_number.'-'.$o_title,'services'=>array()); }
      }
    }
    $output_objlist = array();
    $retstr = '';
    $serviceinfo = '';
    foreach($objlist AS $oID => $oVal){
      $objectservices = array();
      $output_objlist[$oID] = array('obj_title' => $oVal['obj_title'],'services' => array());
      $get_cal_sec = $datapdo->query("SELECT `section_id` FROM `".TABLE_PREFIX."sections` WHERE `object_id`='$oID' AND `module`='calendar' LIMIT 0,1");
      if($datapdo->numRows($get_cal_sec)>0){
        $cal_sec = $datapdo->fetchRow($get_cal_sec,false);
        $secid = $cal_sec['section_id'];
        $get_object_services = $datapdo->query("SELECT * FROM `".TABLE_PREFIX."cal_services` WHERE `object_id`='$oID'");
        $have_services = $datapdo->numRows($get_object_services);
        if($have_services > 0){
          while($object_services = $datapdo->fetchRow($get_object_services,false)){
            $get_servicelabels = $datapdo->query("SELECT `labels` FROM `".TABLE_PREFIX."cal_servicelabels` WHERE `slabel_id`='".$object_services['slabel_id']."' LIMIT 1");
            $servicelabels = $datapdo->fetchRow($get_servicelabels);
            $servicelabel = unserialize($servicelabels['labels']);
            $get_servicefreefld = $object_services['freeflds'];
            if($get_servicefreefld!=''){ $servicefreefld = unserialize($get_servicefreefld); }
            else{ $servicefreefld = array(LANGUAGE=>''); }
            $sadrid = $object_services['saddr_id'];
            $get_sadrfilter_id = $datapdo->get_one("SELECT `adr_type` FROM `".TABLE_PREFIX."address` WHERE `address_id`='$sadrid' LIMIT 1");
            $array_sadrfilter_id = explode('|',$get_sadrfilter_id);
            $showline = false;
            foreach($array_sadrfilter_id AS $safid => $safval){
              if(in_array($safval,$isfilter)){ $showline = true; }
            }
            if($showline == false){ continue 1; }
            $s_company = $admin->get_company($sadrid);
            $s_name = $admin->get_adr_name($sadrid);
            $s_prename = $admin->get_adr_prename($sadrid);
            $s_email = $admin->get_email($sadrid);
            $s_phone1 = $admin->get_phone($sadrid);
            $s_phone2 = $admin->get_phone2($sadrid);
            $s_phone3 = $admin->get_mobile($sadrid);
            $s_phone = (!empty($s_phone1)?$s_phone1:'');
            $s_phone .= (!empty($s_phone2)?(!empty($s_phone)?', ':'').$s_phone2:'');
            $s_phone .= (!empty($s_phone3)?(!empty($s_phone)?', ':'').$s_phone3:'');
            $serviceaddress = (!empty($s_company)?$s_company.', ':'').(!empty($s_prename)?$s_prename.' ':'').$s_name; //(!empty($s_city)?' - '.$s_city:''); //.(!empty($s_phone)?', '.$TEXT['PHONE'].': '.$s_phone:'');
            $servicephone = (!empty($s_phone)?$s_phone:'');
            $servicemail = (!empty($s_email)?$s_email:'');
            $objectservices[] = array('label'=>$servicelabel[LANGUAGE],'freefld'=>$servicefreefld[LANGUAGE],'addrid'=>$sadrid,'addr'=>$serviceaddress,'phone'=>$servicephone,'email'=>$servicemail);
          }
        }
        if(count($objectservices)>0){
          foreach($objectservices AS $si => $sc){ $output_objlist[$oID]['services'][$si]=$sc; }
        }
      }
    }
    // Output the list as addresses
    echo '<div id="listsorterA" style="width:100%;'.$displayadrsort.'">'."\n";
    echo '<table width="100%" cellspacing="0" cellpadding="0">';
    echo '<tr><th colspan="2" style="padding:5px;width:40%;text-align:left;vertical-align:top;">'.$TEXT['ADDRESS'].'</th>'."\n";
    echo '<th style="padding:5px;width:55%;text-align:left;vertical-align:top;">'."\n";
    echo '<table width="100%" cellspacing="0" cellpadding="0">';
    echo '<tr><th style="padding:3px;vertical-align:top;width:40%;text-align:left;">'.$TEXT['OBJECT_TITLE'].'</th><th style="padding:3px;vertical-align:top;width:60%;text-align:left;">'.$TEXT['ASSIGNMENT_SERVICES'].'</th>';
    echo '</table>'."\n";
    echo '</th>'."\n";
    echo '</tr>'."\n";
    $row = 'a';
    foreach($output_list AS $adrId => $adrVal){
      echo '<tr class="row_'.$row.'">'."\n";
      echo '<td style="padding:5px;width:2%;text-align:left;vertical-align:top;">'."\n";
      if($adrVal['adrmail']!='' AND $admin->validate_email($adrVal['adrmail'])==true){
        $atitle = $TEXT['RESERVATIONS'].' '.$TEXT['SEND_TO_MAIL'];
        $aimage = 'email.png';
        $lsender = ARGSO.'sender=send';
      }
      else{
        $atitle = $TEXT['RESERVATIONS'].' '.$TEXT['PRINT'];
        $aimage = 'print_16.png';
        $lsender = ARGSO.'sender=print';
      }
      echo '<a style="outline:none;" name="line'.$adrId.'" href="'.ADMIN_URL.'/addresses/sendres_toservice.php?adr='.$adrId.ARGSO.'limit='.$email_resrange.$lsender.'" title="'.$atitle.'"><img src="'.ADMIN_URL.ADMIN_THEME.'/images/'.$aimage.'" border="0" alt="" /></a>'."\n";
      echo '</td>'."\n";
      echo '<td style="padding:5px;width:38%;text-align:left;vertical-align:top;">'."\n";
      echo '<a style="outline:none;" name="a'.$adrId.'" href="'.ADMIN_URL.'/addresses/adr_modify.php?aid='.$adrId.ARGSO.'back=servlist" title="'.$TEXT['GOTOADDRESS'].'" onmouseover="$(\'.formInfoBox\').hide();$(\'#lastsended'.$adrId.'\').show();">'.$adrVal['address'].'</a>'."\n";
      // Get the last documents
      $getlast_docus = $datapdo->query("SELECT * FROM `".TABLE_PREFIX."cal_servicesdocs` WHERE `sended_to`='$adrId' ORDER BY `senddate` DESC LIMIT 0,3");
      $doccount = $datapdo->numRows($getlast_docus);
      $doccounttitle = ($adrVal['adrmail']==''?$MASSAGE['SERVICES']['LAST_PRINTLIST']:$MASSAGE['SERVICES']['LAST_SENDLIST']);
      if($doccount>0){
        $doccounttitle = $doccount.' '.lcfirst($doccounttitle);
      }
      echo '<div id="lastsended'.$adrId.'" class="formInfoBox" style="margin-top:0.8em;width:auto;white-space: nowrap;line-height:1.5em;">'."\n";
      echo '<div style="float:right;width:1.2em;height:1.2em;background:#ff0000;color:#ffffff;text-align:center;padding:0.1em;cursor:pointer;" onclick="$(\'#lastsended'.$adrId.'\').hide();">X</div>'."\n";
      echo '<b>'.$doccounttitle.'</b>:'."\n";
      if($datapdo->numRows($getlast_docus)>0){
        while($last_docus = $datapdo->fetchRow($getlast_docus)){
          $subject = $last_docus['subject'];
          $lastdate = convert_date(DATE_FORMAT,$last_docus['senddate']);
          $sendtitle = $subject.' '.$TEXT['FROM'].' '.$lastdate;
          $filelink = ADMIN_URL.'/addresses/servdocprint.php?docid='.$last_docus['calservdoc_id'].ARGSOJS.'type='.$last_docus['send_type'];
          echo '<br /><a href="#line'.$adrId.'" title="'.$TEXT['DOCUMENT'].' '.$TEXT['VIEW'].'" onclick="openWin(\''.$filelink.'\',\''.$sendtitle.'\');">'.$sendtitle.'</a>'."\n";
        }
      }
      else{ echo '<br />'.$TEXT['NONE_FOUND']; }
      echo '</div>'."\n";
      echo '</td><td style="width:60%;text-align:left;">'."\n";
      $lastOBJ = '';
      echo '<table width="100%" cellspacing="0" cellpadding="0">';
      foreach($adrVal['services'] AS $servID => $servVal){
        echo '<tr>';
        if($lastOBJ != $servVal['obj']){
          $outOBJ = '<a href="'.ADMIN_URL.'/reservations/mod_obj_services.php?object_id='.$servVal['objid'].ARGSO.'back=8'.'" title="'.entities_to_umlauts($TEXT['ASSIGNMENT_SERVICES'].' '.strtolower($TEXT['MODIFY'])).'">'.$servVal['obj'].'</a>';
        }
        else{
          $outOBJ = '&nbsp;';
        }
        $lastOBJ = $servVal['obj'];
        echo '<td style="padding:3px;vertical-align:top;width:40%;text-align:left;">'.$outOBJ.'</td>'."\n";
        echo '<td style="padding:3px;vertical-align:top;width:60%;text-align:left;">'.$servVal['slabel'].(!empty($servVal['sfreefld'])?' ('.$servVal['sfreefld'].')':'').'</td>';
        echo '</tr>';
      }
      echo '</table>';
      echo '</td>'."\n";
      echo '</tr>'."\n";
      $row = ($row=='a'?'b':'a');
    }
    echo '</table>';
    echo '</div>'."\n";
    // Output the list as objects
    $outputlist_obj = '<div id="listsorterO" style="width:100%;'.$displayobjsort.'">'."\n";
    $outputlist_obj .= '<table width="100%" cellspacing="0" cellpadding="0" style="border: 1px solid #000000;">'."\n";
    $outputlist_obj .= '<tr><th style="padding:3px;vertical-align:top;width:20%;text-align:left;">'.$TEXT['OBJECT_TITLE'].'</th>'."\n";
    $outputlist_obj .= '<th style="padding:3px;vertical-align:top;width:28%;text-align:left;">'.$TEXT['ASSIGNMENT_SERVICES'].'</th><th style="padding:5px;width:52%;text-align:left;vertical-align:top;">'.$TEXT['ADDRESS'].'</th>'."\n";
    $outputlist_obj .= '</tr>'."\n";
    $row = 'a';
    $servicelinecount = 0;
    foreach($output_objlist AS $objId => $objVal){
      $outputlist_obj .= '<tr class="row_'.$row.'"><td style="padding:5px;vertical-align:top;border-top:1px solid #000000;">'.$objVal['obj_title'].'</td><td colspan="2" style="border-top:1px solid #000000;">'."\n";
      if(count($objVal['services'])>0){
        $outputlist_obj .= '<table width="100%" cellspacing="0" cellpadding="0">'."\n";
        foreach($objVal['services'] AS $servK => $servV){
          $adrId = $servV['addrid'];
          $outputlist_obj .= '<tr>'."\n";
          $outputlist_obj .= '<td style="padding:3px;vertical-align:top;width:35%;text-align:left;'.($servicelinecount>0?'border-top:1px solid #888888;':'').'">'.$servV['label'].(!empty($servV['freefld'])?' ('.$servV['freefld'].')':'').'</td>'."\n";
          $outputlist_obj .= '<td style="padding:3px;width:65%;text-align:left;vertical-align:top;'.($servicelinecount>0?'border-top:1px solid #888888;':'').'">'."\n";
          $outputlist_obj .= $servV['addr'];
          $outputlist_obj .= ($servV['phone']!=''?' - '.$TEXT['PHONE'].': '.$servV['phone']:'').($servV['email']!=''?' / '.$TEXT['EMAIL'].': '.$servV['email']:'')."\n";
          $outputlist_obj .= '</td>'."\n";
          $outputlist_obj .= '</tr>'."\n";
          $servicelinecount++;
        }
        $outputlist_obj .= '</table>'."\n";
      }
      else{
        $outputlist_obj .= $TEXT['NONE']."\n";
      }
      $outputlist_obj .= '</td>'."\n";
      $outputlist_obj .= '</tr>'."\n";
      $row = ($row=='a'?'b':'a');
    }
    $outputlist_obj .= '</table>'."\n";
    $outputlist_obj .= '</div>'."\n";
    echo $outputlist_obj;
    // Save the print file to temp
    $filename = 'servicelist.pdf';
    $pathname = BC_PATH.'/temp/';
    $printtitle = $TEXT['ASSIGNMENT_SERVICES'];
    $author = $admin->get_display_name();
    $printlist_obj = '<h2>'.$printtitle.'</h2>'.$outputlist_obj;
    // Delete first an existing file
    if(file_exists($pathname.$filename)){ unlink($pathname.$filename); }
    if(file_exists(BC_PATH.'/lib/include/html2pdf/html2pdf_func.php') AND isset($pathname) AND !empty($pathname) AND !empty($filename)){
      include_once(BC_PATH.'/lib/include/html2pdf/html2pdf_func.php');
      $pdffile = built_pdf_file($printlist_obj,$pathname,$filename,$printtitle,$author,'F','L');
      if(NULL === $pdffile){
        $printlist_error = $TEXT['ERROR'].' PDF '.$TEXT['FILE'].': '.$TEXT['PRINT'].' '.strtolower($TEXT['DISABLED']);
      }
    }

  }
}
if($printlist_error != ''){
  echo '<script type="text/javascript">'."\n";
  echo '  $(document).ready(function(){'."\n";
  echo ' alert("'.entities_to_umlauts($printlist_error).'");';
  echo '    $("#printbutton").attr("disabled",true).css("color","grey");'."\n";
  echo '  });'."\n";
  echo '</script>'."\n";
}
$admin->print_footer();