<?php
/*                                                       */
/* sendres_toservice.php - Send/Print reservations       */
/* $ID 090h - 2023-12-27 - brom $                        */
/*                                                       */
/* BROM CMS/BelCal Project  <http://www.brom-belcal.de> */
/*                                                       */
/* BROM CMS/BelCal is software you can redistribute it  */
/* under the terms the BROM CMS/BelCal license for free */
/* and modify scripts but without warranty. It is not    */
/* redistributable for payment.                          */
/*                                                       */
/* A distribution of payment will be provided            */
/* exclusively by BROM Service see website or send mail. */
/*                                                       */
/* (c) by BROM-Service 2023  (kontakt@brom-belcal.de)    */
/*                                                       */

require('../../config/config.php');
require_once(BC_PATH.'/lib/classes/class.admin.php');
require_once(BC_PATH.'/lib/functions.php');
$admin = new admin('Objects','objects_settings','system');
$user_id = $admin->get_user_id();
if(!$admin->get_permission('calendar_options','module')){
  $admin->print_error($MESSAGE['ADMIN']['INSUFFICIENT_PRIVELLIGES']);
}
if(isset($_POST['submit'])){
    // Send the mail or print the content
  $adr_id = $admin->get_post('adr');
  $sender = $admin->get_post('sender');
  $limit = $admin->get_post('limit');
  $error_url = ADMIN_URL.'/addresses/sendres_toservices.php?adr='.$adr_id.ARGSO.'sender='.$sender.ARGSO.'limit='.$limit;
  $success_url = ADMIN_URL.'/addresses/listservices.php';
  $content = $admin->get_post('content');
  $subject = $admin->get_post('email_subject');
  $subject = entities_to_umlauts($subject);
  $pretext = $admin->get_post('pretext');
  $signum = $admin->get_post('signum');
  $send_type = $admin->get_post('email_type_out');
  $email_from = $admin->get_post('email_from');
  $email_from_name=$admin->get_display_name();
  $email_copy=($admin->get_post('email_copy')==1?true:false);
  $email_to = $admin->get_post('email_to');
  $can_send = ($email_to == ''?false:true);
  if($can_send==true){ $email_sendto = $email_to.($email_copy==true?','.$email_from:''); }
  else{$email_sendto = ($email_copy==true?$email_from:''); }
  $email_body = '<html>'."\n";
  $email_body .= '<head><title>'.$subject.'</title></head>'."\n".'<body>'."\n".'<div style="width:700px">'."\n".$content."\n".'</div>'."\n".'</body>'."\n".'</html>';
  $email_format = 'HTML';
  $addtobody = '<body onload="javascript:window.print()">';
  $print_body = preg_replace('#\<body\>#',$addtobody,$email_body);
  // Save content as file for print
  $file_path = BC_PATH.'/temp/';
  $tmpfile = $file_path.'print-R'.$adr_id.'-'.date("Ymd",time()).'.html';
  $file_name= 'print-R'.$adr_id.'-'.date("Ymd",time()).'.pdf';
  $author = $admin->get_display_name();
  $fp = fopen($tmpfile,'w');
  if(FALSE === fwrite($fp,$print_body)){
    $admin->print_error($TEXT['PRINT'].'-'.$TEXT['ERROR'],$error_url);
  }
  fclose($fp);
  $openfile = str_replace(BC_PATH,BC_URL,$tmpfile);

  $attachment = array();
  $error_pdf = '';
  if($send_type == 'PDF' AND file_exists(BC_PATH.'/lib/include/html2pdf/html2pdf_func.php') AND isset($file_path) AND !empty($file_path) AND !empty($file_name)){
    include_once(BC_PATH.'/lib/include/html2pdf/html2pdf_func.php');
    $attachfile = built_pdf_file($content,$file_path,$file_name,$subject,$author);
    $openfile = str_replace(BC_PATH,BC_URL,$file_path).$file_name;
    if(NULL === $attachfile){
      $email_format = 'HTML';
      $email_body = $content.'<p>'.nl2br($signum).'</p>';
      $error_pdf = 'PDF '.$TEXT['FILE'].': '.$MESSAGE['OBJECTS']['CANNOT_REORDER'];
    }
    else{
      $attachment[] = array($attachfile,$file_name);
      $email_body = $pretext.chr(10).$signum;
      $email_format = 'TEXT';
    }
  }
  else{
    $email_format = 'HTML';
    $email_body = $content.'<p>'.nl2br($signum).'</p>';
  }
  $success = false;
  $success_copy = false;
  $must_print = false;
  $saveresult = true;
  $confirmReadSet = 0;
  $confirmRead = '';
  if(isset($_POST['confirmRead'])){
    $confirmReadSet = $admin->get_post_escaped('confirmRead');
    $confirmRead = ($confirmReadSet == 1?$email_from:'');
  }

  if($email_sendto != ''){
    $get_mbox = $datapdo->query("SELECT * FROM `".TABLE_PREFIX."mailboxes` WHERE `user_id`='".$admin->get_user_id()."' ORDER BY `mailbox_id` LIMIT 0,1");
    if($datapdo->numRows($get_mbox)>0){
      require_once(BC_PATH.'/lib/functions.php');
      $box = $datapdo->fetchRow($get_mbox);
      $mailbox = $box['position']-1;
      $pass = $admin->get_cryption($box['password'],$box['imapuser'],true);
      require_once(BC_PATH.'/lib/classes/class.imap.php');
      $imap = new imap($box['imapserver'],$box['imapport'],$box['imapuser'],$pass,$box['imaptype'],$box['sentfolder']);
      if(!$imap){ $saveresult = false; }
    }
    else{ $saveresult = false; }
    $success = $admin->mail($email_from,$email_sendto,$subject,$email_body,$email_from_name,$email_format,$attachment,$saveresult,$confirmRead);
    if($success == false){
      $success = $admin->mail(SERVER_EMAIL,$email_sendto,$subject,$email_body,$email_from_name,$email_format,$attachment,$saveresult,$confirmRead);
    }
    if($success == false){
      $admin->print_error($TEXT['ERROR'].': '.$email_to,$error_url);
    }
    else{
      if($saveresult == true){
        $insent = $imap->saveMailMsgInSent($success);
        $imap = NULL;
      }
    }
  }
  if($can_send==false){
    $must_print = true;
    $success = true;
  }
  if($success == true){
    $outfile = BC_PATH.str_replace(BC_URL,'',$openfile);
    $handle = fopen($outfile,"rb");
    $newcontent = fread($handle, filesize($outfile));
    fclose($handle);
    $base64content = base64_encode($newcontent);
    // Save the document into db
    $document = ($send_type == 'PDF'?$base64content:$content);
    $insertquery = "INSERT INTO `".TABLE_PREFIX."cal_servicesdocs`"
	    ." (`user_id`,`send_type`,`sended_to`,`subject`,`document`,`senddate`) VALUES"
	    ." ('$user_id','".($send_type=='PDF'?1:0)."','$adr_id','$subject','$document','".time()."')";
    $datapdo->query($insertquery);

    if($can_send == true){
      $admin->print_success($TEXT['SUCCESS'].($error_pdf!=''?'<br />'.$error_pdf:''),$success_url);
    }
    else{
      if($must_print == true){
        if(file_exists(BC_PATH.'/lib/winopen.inc.php')){ include(BC_PATH.'/lib/winopen.inc.php');
          echo '<script type="text/javascript">'."\n";
          echo '$(document).ready(function(){ openWin("'.$openfile.'","'.$subject.'","'.$subject.'"); });'."\n";
          echo '</script>'."\n";
        }
        else{
          $admin->print_error($TEXT['PRINT'].'-'.$TEXT['ERROR'].($error_pdf!=''?'<br />'.$error_pdf:''),$error_url);
        }
        $admin->print_error($TEXT['SUCCESS'].($error_pdf!=''?'<br />'.$error_pdf:''),$success_url);
      }
    }
  }
}
else{
  if(!isset($_GET['adr']) OR !is_numeric($_GET['adr'])){
    $admin->print_error($MESSAGE['ADMIN']['INSUFFICIENT_PRIVELLIGES']);
  }
  else{
    // Include calendar languages
    if(!file_exists(BC_PATH .'/modules/calendar/languages/'.LANGUAGE .'.php')) {
      // no module language file exists for the language set by the user, include default module language file EN.php
      require(BC_PATH .'/modules/calendar/languages/EN.php');
    }
    else {
      // a module language file exists for the language defined by the user, load it
      require(BC_PATH .'/modules/calendar/languages/'.LANGUAGE .'.php');
    }
    if(file_exists(BC_PATH .'/modules/calendar/languages/user_'.LANGUAGE .'.php')) {
      require(BC_PATH .'/modules/calendar/languages/user_'.LANGUAGE .'.php');
    }
    // include function for wysiwyg editor
    if(!isset($_GET['wysiwyg']) OR $_GET['wysiwyg'] != 'no') {
	if (!defined('WYSIWYG_EDITOR') OR WYSIWYG_EDITOR=="none" OR !file_exists(BC_PATH.'/modules/'.WYSIWYG_EDITOR.'/include.php')) {
		function show_wysiwyg_editor($name,$id,$content,$width,$height,$block) {
			echo '<textarea name="'.$name.'" id="'.$id.'" style="width: '.$width.'; height: '.$height.';">'.$content.'</textarea>';
		}
	} else {
		$id_list=array('content');
		require_once(BC_PATH.'/modules/'.WYSIWYG_EDITOR.'/include.php');
	}
    }

    // Get objects this address for service
    $adr_id = $admin->get_get('adr');
    $sender = $admin->get_get('sender');
    $provider_adress = $admin->get_adr_complate($adr_id);
    $provider_email = $admin->get_email($adr_id);
    $sender_email = $admin->get_email();
    $send_subject = $TEXT['RESERVATIONS'].' - '.$TEXT['CURRENT'];
    $line_array = array();
    $linecounter = 0;
    $print_labels = '';
    $get_sendsettings = $datapdo->query("SELECT * FROM `".TABLE_PREFIX."cal_sendservices` WHERE `user_id`='$user_id' LIMIT 0,1");
    if($datapdo->numRows($get_sendsettings)>0){
      $sendsettings = $datapdo->fetchRow($get_sendsettings);
      $send_type = ($sendsettings['send_type']==1?'PDF':'HTML');
      $send_copy = $sendsettings['send_copy'];
      $send_pretext = $sendsettings['pretext'];
      $send_subject = $sendsettings['subject'];
      $send_signum = $sendsettings['signum'];
      $res_range = $sendsettings['res_range'];
      switch ($res_range){
        case 5;
          $out_range = mktime(12,0,0,(date('n',time())+12),date('j',time()),date('Y',time()));
          $range_sql = " AND `res_end`<'".$out_range."'";
          break;
        case 4;
          $out_range = mktime(12,0,0,(date('n',time())+6),date('j',time()),date('Y',time()));
          $range_sql = " AND `res_end`<'".$out_range."'";
          break;
        case 3;
          $out_range = mktime(12,0,0,(date('n',time())+3),date('j',time()),date('Y',time()));
          $range_sql = " AND `res_end`<'".$out_range."'";
          break;
        case 2;
          $out_range = mktime(12,0,0,(date('n',time())+2),date('j',time()),date('Y',time()));
          $range_sql = " AND `res_end`<'".$out_range."'";
          break;
        case 1;
          $out_range = mktime(12,0,0,(date('n',time())+1),date('j',time()),date('Y',time()));
          $range_sql = " AND `res_end`<'".$out_range."'";
          break;
        default:
          $out_range = '';
          $range_sql = '';
      }
      $date_range = ($out_range != ''?' '.$TEXT['TERMIN_END_TO'].' '.convert_date(DATE_FORMAT,$out_range):'');
      $services = $datapdo->query("SELECT o.`object_id`,t.`labels` FROM `".TABLE_PREFIX."cal_services` AS o, `".TABLE_PREFIX."cal_servicelabels` AS t WHERE o.`saddr_id`='$adr_id' AND t.`slabel_id`=o.`slabel_id` ORDER by o.`object_id` ASC");
      if($datapdo->numRows($services)>0){
        while($objects = $datapdo->fetchRow($services)){
          $obj_id = $objects['object_id'];
          if($linecounter != $obj_id){ $print_labels = ''; }
          $linecounter = $obj_id;
          $serv_labels = unserialize($objects['labels']);
          $print_labels .= ($print_labels==''?' - ':', ').$serv_labels[LANGUAGE];
          $object_title = get_object_title($obj_id);
          $line_array[$linecounter] = array('object'=>$object_title,'reslines'=>array());
          $get_reservations = $datapdo->query("SELECT `res_start`,`res_end`,`client_id`,`name`,`status` FROM `".TABLE_PREFIX."reservations` WHERE `object_id`='$obj_id' AND `status`>'0' AND `status`<'5' AND `res_end`>'".time()."'".$range_sql." ORDER BY `res_start`ASC");
          if($datapdo->numRows($get_reservations)>0){
            while($reservations = $datapdo->fetchRow($get_reservations)){
              $s_date = (date('N',$reservations['res_start'])==7?'<span style="color:red;">':'').convert_day_month_to_str('daystr',date('N',$reservations['res_start'])).(date('N',$reservations['res_start'])==7?'</span>':'').', ';
              $s_date .= date("d.m.Y",$reservations['res_start']);
              $e_date = (date('N',$reservations['res_end'])==7?'<span style="color:red;">':'').convert_day_month_to_str('daystr',date('N',$reservations['res_end'])).(date('N',$reservations['res_end'])==7?'</span>':'').', ';
              $e_date .= date("d.m.Y",$reservations['res_end']);
              $getstatus = $reservations['status'];
//              if($getstatus == 5){ continue 1; }
              $status = ($getstatus==4?$CALTEXT['RES3s']:$CALTEXT['RES'.$getstatus]);
              $get_c_names = $datapdo->query("SELECT `address_id` FROM `".TABLE_PREFIX."address` WHERE `client_id`='".$reservations['client_id']."' LIMIT 0,1");
              if($datapdo->numRows($get_c_names)>0){
                $c_names = $datapdo->fetchRow($get_c_names);
                $aID = $c_names['address_id'];
                $c_company = $admin->get_company($aID);
                $c_prename = ''; //$admin->get_adr_prename($aID);
                $c_name = $admin->get_adr_name($aID);
                $c_address = ($c_company!=''?$c_company.', ':'').$c_name.($c_prename!=''?', '.$c_prename:'');
              }
              else{ $c_address = $reservations['name']; }
              $line_array[$linecounter]['reslines'][] = array('sdate'=>$s_date,'edate'=>$e_date,'status'=>$status,'name'=>$c_address);
            }
          }
          else{
            $line_array[$linecounter]['reslines'][] = array('sdate'=>'','edate'=>'','status'=>'','name'=>'');
          }
        }
      }
    }
    $output = '';
    if(count($line_array)>0){
      // The header with address from service provider
      $output .= '<h2>'.$TEXT['RESERVATIONS'].' - '.$TEXT['CURRENT'].$date_range.'</h2>'."\n";
      $output .= '<p>'.$provider_adress.'</p>'."\n";
      $output .= '<table cellpadding="2" cellspacing="2" style="width:100%;border:1px solid #555555;">'."\n";
      foreach($line_array AS $line => $value){
        $output .= '<tr style="background-color:#C0C0C0;">'."\n";
        $output .= '<th colspan="3" style="width:100%;padding:3px;text-align:left;">'.$TEXT['OBJECT'].': '.$value['object'].'</th>'."\n";
        $output .= '</tr>'."\n";
        foreach($value['reslines'] AS $resK => $resV){
          $output .= '<tr>'."\n";
          if($resV['sdate']==''){
            $output .= '<td colspan="3" style="border-bottom:1px solid #555555;width:100%;text-align:left;padding:3px;">'.$TEXT['CURRENT'].': '.$TEXT['NONE'].' '.$TEXT['RESERVATIONS'].'</td></tr>'."\n";
          }
          else{
            $output .= '<td style="border-bottom:1px solid #555555;width:45%;text-align:left;padding:3px;">'.$resV['sdate'].' - '.$resV['edate'].'</td><td style="border-bottom:1px solid #555555;width:20%;text-align:center;padding:3px;">'.$resV['status'].'</td><td style="border-bottom:1px solid #555555;width:35%;text-align:left;padding:3px;">'.$resV['name'].'</td></tr>'."\n";
          }
        }
      }
      $output .= '</table>'."\n";
    }
    else{
      echo $TEXT['NONE_FOUND'];
    }
    if($output != ''){ ?>
<script type="text/javascript">
function set_pretext_visible(typ){
  if(typ==''){ typ = $("#send_type").val(); }
  var getmail = $("#email_to").val();
  var ismail = (getmail==''?0:1);
  if(ismail == 1){
    $('#display_confirmread').show();
    $('#display_signum').shoe();
    $('#textformat').text('<?php echo $CALTEXT['MAIL_FORMAT']; ?>');
    $('#submitbutton').val('<?php echo $TEXT['SEND']; ?>');
    if(typ == 'PDF'){ $('#pretexttable').show(); }
    else{ $('#pretexttable').hide(); }
  }
  else{
    $('#display_confirmread').hide();
    $('#display_signum').hide();
    $('#textformat').text('<?php echo $CALTEXT['PRINT_FORMAT']; ?>');
    $('#submitbutton').val('<?php echo $TEXT['PRINT']; ?>');
    $('#pretexttable').hide();
  }
};
</script>
    <?php
      $show_pretext = ($send_type=='PDF'?'':' style="display:none;"');
      $show_signum = ($sender=='send'?'':' style="display:none;"');
      echo '<form name="sendmail" action="'.$_SERVER['PHP_SELF'].'" method="post">'."\n";
      echo '<input type="hidden" name="adr" value="'.$adr_id.'" />'."\n";
      echo '<input type="hidden" name="sender" value="'.$sender.'" />'."\n";
      echo '<input type="hidden" name="limit" value="'.$res_range.'" />'."\n";
      echo '<input type="hidden" id="send_type" name="email_type_out" value="'.$send_type.'" />'."\n";
      echo '<input type="hidden" name="email_copy" value="'.$send_copy.'" />'."\n";
      echo '<table width="100%" cellspacing="ellspacing="0" cellpadding="2">'."\n";
      echo '<tr>'."\n";
      echo '<td class="setting_name">'.$TEXT['EMAIL_FROM'].':</td>'."\n";
      echo '<td class="setting_value"><input name="email_from" value="'.$sender_email.'" /></td>'."\n";
      echo '</tr>'."\n";
      echo '<tr>'."\n";
      echo '<td class="setting_name">'.$TEXT['EMAIL_ADDRESS'].':</td>'."\n";
      echo '<td class="setting_value"><input id="email_to" name="email_to" value="'.$provider_email.'" onchange="set_pretext_visible();" /></td>'."\n";
      echo '</tr>'."\n";
      $DISPLAY_CONFIRMREAD = (empty($provider_email)?' style="display:none;"':'');
      $subject = entities_to_umlauts($TEXT['RESERVATIONS'].' - '.$TEXT['CURRENT']);
      echo '<tr>'."\n";
      echo '<td class="setting_name">'.$TEXT['SUBJECT'].':</td>'."\n";
      echo '<td class="setting_value"><input name="email_subject" value="'.$send_subject.'" /></td>'."\n";
      echo '</tr>'."\n";
      echo '<tr>'."\n";
      echo '<td colspan="2">'.$TEXT['EMAIL_CONTENT'].':</td>'."\n";
      echo '</tr>'."\n";
      echo '<tr>'."\n";
      echo '<td colspan="2">'."\n";
      $heights = get_wysiwyg_conf('reservations');
      $height = (($heights != NULL AND $heights['default_height']>0)?$heights['default_height']:'350').'px';
      show_wysiwyg_editor('content','content',$output,'99%',$height,0);
      echo '</td>'."\n";
      echo '</tr>'."\n";
      echo '<tr>'."\n";
      echo '</table>'."\n";
      echo '<table cellpadding="5" cellspacing="0" border="0" align="center" width="100%"'.$show_pretext.' id="pretexttable">'."\n";
      echo '  <tr>'."\n";
      echo '    <td class="setting_name" style="vertical-align:top;">',$CALTEXT['PRETEXT_INFO'].':</td>'."\n";
      echo '    <td class="setting_value"><textarea id="pretext" name="pretext" cols="120" rows="4" style="width:95%">'.strip_tags(str_replace('<br />',chr(10),$send_pretext)).'</textarea></td>'."\n";
      echo '  </tr>'."\n";
      echo '</table>'."\n";
      echo '<table id="display_signum" cellpadding="5" cellspacing="0" border="0" align="center" width="100%"'.$show_signum.' id="signumtable">'."\n";
      echo '  <tr>'."\n";
      echo '    <td class="setting_name" style="vertical-align:top;">',$TEXT['SIGNUM'].':</td>'."\n";
      echo '    <td class="setting_value"><textarea id="signum" name="signum" cols="120" rows="4" style="width:95%">'.strip_tags(str_replace('<br />',chr(10),$send_signum)).'</textarea></td>'."\n";
      echo '  </tr>'."\n";
      echo '</table>'."\n";
      echo '<table id="display_confirmread"'.$DISPLAY_CONFIRMREAD.' cellpadding="5" cellspacing="0" border="0" align="center" width="100%">'."\n";
      echo '<tr><td width="30%">'.$TEXT['CONFIRM_READ'].':</td>'."\n";
      echo '<td width="70%">'."\n";
      echo '<input id="confirmread_true" type="radio" name="confirmRead" value="1"'.((isset($_SESSION['email_posted']['CONFIRMREAD']) AND $_SESSION['email_posted']['CONFIRMREAD']==1)?' checked="checked"':'').' />'."\n";
      echo '<label for="confirmread_true">'.$TEXT['YES'].'</label>'."\n";
      echo '<input id="confirmread_false" type="radio" name="confirmRead" value="0"'.((!isset($_SESSION['email_posted']['CONFIRMREAD']) OR $_SESSION['email_posted']['CONFIRMREAD']==0)?' checked="checked"':'').' />'."\n";
      echo '<label for="confirmread_false">'.$TEXT['NO'].'</label>'."\n";
      echo '</td>'."\n";
      echo '</tr></table>'."\n";
      echo '<table width="100%" cellspacing="ellspacing="0" cellpadding="2">'."\n";
      echo '<tr>'."\n";
      echo '<td style="width:50%;text-align:left;">'."\n";
      echo '<input type="button" name="back" value="'.$TEXT['BACK'].'" style="width:99%" onclick="location.href=\''.ADMIN_URL.'/addresses/listservices.php\';" />'."\n";
      echo '</td>'."\n";
      echo '<td style="width:50%;text-align:right;">'."\n";
      echo '<input id="submitbutton" type="submit" name="submit" value="'.($sender=='send'?$TEXT['SEND']:$TEXT['PRINT']).'" style="width:99%" />'."\n";
      echo '</td>'."\n";
      echo '</tr>'."\n";
      echo '</table>'."\n";
      echo '</form>'."\n";
    }
    else{ $admin->print_error($MESSAGE['OBJECTS']['CANNOT_REORDER'],ADMIN_URL.'/addresses/listservices.php'); }
  }
}
$admin->print_footer();